<id>
ChatBox - YaBB 2.7.00
</id>

<version>
1.6
</version>

<mod info>
This mod adds a Chat Box with wysiwyg editor to your 2.7.00 Forum.
Besides a "General Chat" room it uses the existing Board names as Chat room names.
It'll show a list of participants for every Chat room.
Participants can start/stop Chat auto-update.

Admin can:
- Enable / disable Chat
- Enable Chat Button on Message Index
- Enable / disable alert before deleting a Chat message
- Exclude Board names not wanted as Chat rooms
- Set max. number of characters in a Chat message
- Set the number of minutes Chat messages stay alive
- Set the number of minutes inactive participants stay in the Chat log
- Set Chat/participants update rate in seconds

You must also create a 'chat' folder in the Variables folder. CHMOD this to 755.

Apply this mod using YaBMod.

Go to "Admin Center - Forum Settings - Chat" and check "Enable Chat".

The "Chat" tab is positioned as the last tab in the menu. You can use "Edit tabs" to push it to another position.
</mod info>

<author>
Carsten (updated for 2.7.00 by Dandello)
</author>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    my $chatbox = "ChatBox|Carsten (updated for 2.7.00 Strict by Dandello)|This mod adds a chat box.|1.6|Aug 10, 2017";
    push  @installed_mods, $chatbox;
</add before>

<edit file>
Admin/NewSettings.pm
</edit file>

<search for>
if (@newsettingspmmods) {
</search for>

<add before>
push @newsettingspmmods, 'ChatBox';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ($enablechat, $mibutton, $removealert, $MaxChatLen, $message_term, $part_term, $update_freq, $ChatRoom);
</add before>

<search for>
## Modlinks MOD hook ##
</search for>

<add before>
        $modlinks{'chat'} = $enablechat;
        $modadd{'chat'} = '|1|1|0|1|0|';
</add before>

<search for>
1;
EOF
</search for>

<add before>
########## Chat configuration ##########

\$enablechat = $enablechat;             # Set to 1 to enable Chat CE
\$mibutton = $mibutton;                 # Set to 1 to show Chat Button in Message Index
\$removealert = $removealert;               # Set to 1 to show alert before removing a chat comment
\$MaxChatLen = $MaxChatLen;             # Max. characters in a chat message.
\$message_term = $message_term;             # Number of minutes a chat message will stay alive.
\$part_term = $part_term;                   # Number of minutes a inactive participant will stay in the chat log.
\$update_freq = $update_freq;                   # Update frequency in seconds.
\$ChatRoom = "$ChatRoom";               # Board names to exclude as Chat Room names.

</add before>


<edit file>
Admin/Settings_Main.pm
</edit file>

<search for>
if (@settings_mainpmmods) {
</search for>

<add before>
push @settings_mainpmmods, 'ChatBox';
</add before>

<search for>
load_language('Register');
</search for>

<add after>
load_language('Mods/ChatBox');
</add after>

<search for>
## our Mod Hook ##
</search for>

<add before>
# Chat room selector
our (@categoryorder, %catinfo, $ChatRoom, %board, %cat, %subboard, $message_term, $part_term, $update_freq, $MaxChatLen, $enablechat, %chatce_txt, $mibutton, $removealert );
$ChatRoom ||= q{};
get_forum_master();
my $catoptions = q{};
for my $catid (@categoryorder) {
    my ($catname) = ${$catinfo{$catid}}[0];
    to_chars($catname);
    my @sellist = split /\, /sm, $ChatRoom;
    my $testcatid = $catid . '_cat';
    my $catbdselected = q{};
    for (@sellist) {
        if($_ eq $testcatid) { $catbdselected = qq~ selected="selected"~; }
    }
    $catoptions .= qq~<option value="$testcatid" style="color: #000000; background-color: #FFFEDF; border-bottom: 1px dotted #D6B2FF; border-top: 1px dotted #D6B2FF;"$catbdselected>$catname</option>\n~;
    my @bdlist = @{$cat{$catid}};
    for my $curboard (@bdlist) {
        my $bdselected = q{};
        my ($boardname, undef, undef) = @{$board{$curboard}};
        for (@sellist) {
            if($_ eq $curboard || $catbdselected ne q{}) { $bdselected = q~ selected="selected"~; }
        }
        $catoptions .= qq~<option value="$curboard"$bdselected>&nbsp; $boardname</option>\n~;
        if ( $subboard{$curboard} ) {
            my @bdsublist = @{$subboard{$curboard}};
            for my $sbcurboard (@bdsublist) {
                my $bdsubselected = q{};
                my ($subboardname, undef, undef) = @{$board{$sbcurboard}};
                for (@sellist) {
                    if($_ eq $sbcurboard || $catbdselected ne q{}) { $bdsubselected = q~ selected="selected"~; }
                }
                $catoptions .= qq~<option value="$sbcurboard"$bdsubselected>&nbsp; &nbsp;-$subboardname</option>\n~;
            }
        }
    }
}

if ( !$message_term ) { $message_term = 120; }
if ( !$part_term ) { $part_term = 15; }
if ( !$update_freq ) { $update_freq = 10; }
if ( !$MaxChatLen ) { $MaxChatLen = 300; }
</add before>

<search for>
                  [ 'enable_alert', 'pm_level!=0', 'enable_bm_level!=0' ],
            },
        ],
    },
</search for>

<add after>
    {
        name  => $chatce_txt{'chatbox'},
        id    => 'chatce',
        items => [
            {
                header => $chatce_txt{'showhide'},
            },
            {
                description => $chatce_txt{'enablechat'},
                input_html => qq~<input type="checkbox" name="enablechat" value="1"${ischecked($enablechat)} />~,
                name => 'enablechat',
                validate => 'boolean',
            },
            {
                description => $chatce_txt{'mibutton'},
                input_html => qq~<input type="checkbox" name="mibutton" value="1"${ischecked($mibutton)} />~,
                name => 'mibutton',
                validate => 'boolean',
            },
            {
                description => $chatce_txt{'remalert'},
                input_html => qq~<input type="checkbox" name="removealert" value="1"${ischecked($removealert)} />~,
                name => 'removealert',
                validate => 'boolean',
            },
            {
                description => $chatce_txt{'boardexcl'},
                input_html => qq~<select multiple="multiple" name="ChatRoom" size="8">$catoptions</select>~,
                name => 'ChatRoom',
                validate => 'text,null',
            },
            {
                header => $chatce_txt{'timers'},
            },
            {
                description => $chatce_txt{'maxchar'},
                input_html => qq~<input type="text" maxlength="4" size="3" name="MaxChatLen" value="$MaxChatLen" />~,
                name => 'MaxChatLen',
                validate => 'number,null',
            },
            {
                description => $chatce_txt{'messageterm'},
                input_html => qq~<input type="text" maxlength="4" size="3" name="message_term" value="$message_term" />~,
                name => 'message_term',
                validate => 'number,null',
            },
            {
                description => $chatce_txt{'partterm'},
                input_html => qq~<input type="text" maxlength="4" size="3" name="part_term" value="$part_term" />~,
                name => 'part_term',
                validate => 'number,null',
            },
            {
                description => $chatce_txt{'updatefrq'},
                input_html => qq~<input type="text" maxlength="4" size="3" name="update_freq" value="$update_freq" />~,
                name => 'update_freq',
                validate => 'number,null',
            },
        ],
    },
</add after>

<edit file>
Languages/English/Menu.lng
</edit file>

<search for>
if (@englishmenulngmods) {
</search for>

<add before>
push @englishmenulngmods, 'ChatBox';
</add before>

<search for>
require Sources::Menu;
</search for>

<add before>
$img_txt{'chatce'} = 'Chat';

</add before>

<edit file>
Languages/English/tabtext.txt
</edit file>

<search for>
1;
</search for>

<add before>
$tabtxt{'chat'} = 'Chat';
</add before>

<edit file>
Sources/MessageIndex.pm
</edit file>

<search for>
if (@messageindexpmmods) {
</search for>

<add before>
push @messageindexpmmods, 'ChatBox';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ( $mibutton, $ChatRoom );
</add before>

<search for>
    if ( access_check( $currentboard, 3 ) eq 'granted' ) {
        $polllink =
qq~$menusep<a href="$scripturl?board=$INFO{'board'};action=post;title=CreatePoll">$img{'createpoll'}</a>~;
    }
</search for>

<add after>
    my $chatcelink = q{};
    if(!$iamguest && $mibutton) {
        my @excllist = split /\, /sm, $ChatRoom;
        my $testcatid = $catid . '_cat';
        my $useboard = 1;
        foreach (@excllist) {
            if ($_ eq $currentboard || $_ eq $testcatid) { $useboard = 0; }
        }
        if($useboard) {
            $chatcelink = qq~$menusep<a href="$scripturl?action=chat;room=$currentboard">$img{'chatce'}</a>~;
        }
    }
</add after>

<search for>
## Mod Hook outside_threadtools ##
</search for>

<add before>
    $outside_threadtools =~ s/\Q{yabb chatce button}\E/$chatcelink/gxsm;
</add before>

<edit file>
Sources/SubList.pm
</edit file>

<search for>
if (@sublistpmmods) {
</search for>

<add before>
push @sublistpmmods, 'ChatBox';
</add before>

<search for>
1;
</search for>

<add before>
## ChatBox Mod ##
$director{'chat'} = 'Mods/ChatBox.pm&chatCE';
$director{'cdchatopen'} = 'Mods/ChatBox.pm&chatCE_open';
$director{'cdchatupdate'} = 'Mods/ChatBox.pm&chatCE_open';
$director{'cdupdatechat'} = 'Mods/ChatBox.pm&UpdateChat';
$director{'cdupdatepart'} = 'Mods/ChatBox.pm&UpdateParticipants';
$director{'createlink'} = 'Mods/ChatBox.pm&InsertLink';
$director{'cdchatpalette'} = 'Mods/ChatBox.pm&ColorPicker';

</add before>

<edit file>
Sources/TabMenu.pm
</edit file>

<search for>
if (@tabmenupmmods) {
</search for>

<add before>
push @tabmenupmmods, 'ChatBox';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ($enablechat);
</add before>

<search for>
    our $yytabmenu = qq~<ul>\n~;
</search for>

<add before>
    if (!$iamguest && $enablechat) {
        $tab{'chatce'} = qq~$tabhtml_l"$scripturl?action=chat" title="$img_txt{'chatce'}">$img_txt{'chatce'}</a>$tabhtml_r~;
    }
</add before>

<edit file>
Templates/default/MessageIndex.template
</edit file>

<search for>
if (@defaultmessageindexmods) {
</search for>

<add before>
push @defaultmessageindexmods, 'ChatBox';
</add before>

<search for>
$outside_threadtools = join '', @outside_threadtools;
</search for>

<add before>
push @outside_threadtools, '{yabb chatce button}';
</add before>

<edit file>
Templates/default/Menu.def
</edit file>

<search for>
1;
</search for>

<add before>
$img_set{'chatce'} = ['chat1', 'img_txt', 'chatce','','','imgcatbg','png','mod'];
</add before>

<edit file>
<html>Templates/Forum/default.css
</edit file>

<search for>
/* Mod Hook End*/
</search for>

<add before>
.deftpalchat {
    border: 0;
    cursor: pointer;
    float: left;
    font-size: 5px;
    height: 15px;
    margin-bottom: 1px;
    margin-right: 1px;
    width: 15px;
}

</add before>